#include "qalculator.h"
#include "ui_qalculator.h"

//Globale Variablen
bool dotExists = false;
bool clearDisplay = false;
bool storeIt = false;
bool recallIt = false;
bool calcPercent = false;
double temp1 = 0;
double temp2 = 0;
double erg = 0;
double tempStore = 0;
double store1 = 0;
double store2 = 0;
double store3 = 0;
double tempPercent = 0;
const double PI = 3.1415926;
QString action = "";
//end variablen

Qalculator::Qalculator(QWidget *parent)
    : QWidget(parent), ui(new Ui::QalculatorClass)
{
    ui->setupUi(this);

    connect(ui->num0, SIGNAL(clicked()), this, SLOT(num0()));
    connect(ui->num1, SIGNAL(clicked()), this, SLOT(num1()));
    connect(ui->num2, SIGNAL(clicked()), this, SLOT(num2()));
    connect(ui->num3, SIGNAL(clicked()), this, SLOT(num3()));
    connect(ui->num4, SIGNAL(clicked()), this, SLOT(num4()));
    connect(ui->num5, SIGNAL(clicked()), this, SLOT(num5()));
    connect(ui->num6, SIGNAL(clicked()), this, SLOT(num6()));
    connect(ui->num7, SIGNAL(clicked()), this, SLOT(num7()));
    connect(ui->num8, SIGNAL(clicked()), this, SLOT(num8()));
    connect(ui->num9, SIGNAL(clicked()), this, SLOT(num9()));

    connect(ui->dotButton, SIGNAL(clicked()), this, SLOT(dotButton()));
    connect(ui->clearButton, SIGNAL(clicked()), this, SLOT(clearButton()));
    connect(ui->addButton, SIGNAL(clicked()), this, SLOT(addButton()));
    connect(ui->isButton, SIGNAL(clicked()), this, SLOT(isButton()));
    connect(ui->subButton, SIGNAL(clicked()), this, SLOT(subButton()));
    connect(ui->multButton, SIGNAL(clicked()), this, SLOT(multButton()));
    connect(ui->divButton, SIGNAL(clicked()), this, SLOT(divButton()));
    connect(ui->changeSign, SIGNAL(clicked()), this, SLOT(changeSign()));
    connect(ui->stoButton, SIGNAL(clicked()), this, SLOT(store()));
    connect(ui->rclButton, SIGNAL(clicked()), this, SLOT(recall()));
    connect(ui->ceButton, SIGNAL(clicked()), this, SLOT(clearEntry()));
    connect(ui->PI, SIGNAL(clicked()), this, SLOT(showPI()));
    connect(ui->backButton, SIGNAL(clicked()), this, SLOT(back()));
    connect(ui->sinButton, SIGNAL(clicked()), this, SLOT(calcSIN()));
    connect(ui->cosButton, SIGNAL(clicked()), this, SLOT(calcCOS()));
    connect(ui->tanButton, SIGNAL(clicked()), this, SLOT(calcTAN()));
    connect(ui->sqrtButton, SIGNAL(clicked()), this, SLOT(calcSQRT()));
    connect(ui->squareButton, SIGNAL(clicked()), this, SLOT(calcSquare()));
    connect(ui->percentButton, SIGNAL(clicked()), this, SLOT(percent()));
}

Qalculator::~Qalculator()
{
    delete ui;
}

void Qalculator::num0()
{
    if (storeIt == true)
    {
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        recallIt = false;
        return;
    }
    if (clearDisplay == true)
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    if (displayContent != "0")
    {
        displayContent.append("0");
        ui->display->setText(displayContent);
    }
}
void Qalculator::num2()
{
    if (storeIt == true)
    {
        store2 = tempStore;
        tempStore = 0;
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        ui->display->setText(QString::number(store2));
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("2");
    ui->display->setText(displayContent);
}
void Qalculator::num3()
{
    if (storeIt == true)
    {
        store3 = tempStore;
        tempStore = 0;
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        ui->display->setText(QString::number(store3));
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("3");
    ui->display->setText(displayContent);
}
void Qalculator::num4()
{
    if (storeIt == true)
    {
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("4");
    ui->display->setText(displayContent);
}
void Qalculator::num5()
{
    if (storeIt == true)
    {
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("5");
    ui->display->setText(displayContent);
}
void Qalculator::num6()
{
    if (storeIt == true)
    {
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("6");
    ui->display->setText(displayContent);
}
void Qalculator::num7()
{
    if (storeIt == true)
    {
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("7");
    ui->display->setText(displayContent);
}
void Qalculator::num8()
{
    if (storeIt == true)
    {
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("8");
    ui->display->setText(displayContent);
}
void Qalculator::num9()
{
    if (storeIt == true)
    {
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("9");
    ui->display->setText(displayContent);
}
void Qalculator::num1()
{
    if (storeIt == true)
    {
        store1 = tempStore;
        tempStore = 0;
        storeIt = false;
        return;
    }
    if (recallIt == true)
    {
        ui->display->setText(QString::number(store1));
        recallIt = false;
        return;
    }
    if (clearDisplay == true || ui->display->text() == "0")
    {
        ui->display->clear();
        clearDisplay = false;
    }
    QString displayContent = ui->display->text();
    displayContent.append("1");
    ui->display->setText(displayContent);
}

void Qalculator::dotButton()
{

    if (temp1 != 0 || dotExists == false)
    {
        QString displayContent = ui->display->text();
        displayContent.append(".");
        ui->display->setText(displayContent);
        dotExists = true;
        if (temp1 != 0)
            clearDisplay = false;
    }
}

void Qalculator::clearButton()
{
    dotExists = false;
    clearDisplay = false;
    storeIt = false;
    recallIt = false;
    temp1 = 0;
    temp2 = 0;
    erg = 0;
    tempStore = 0;
    store1 = 0;
    store2 = 0;
    store3 = 0;
    action = "";

    ui->display->clear();
    ui->display->setText("0");
}

void Qalculator::addButton()
{
    temp1 = ui->display->text().toDouble();
    clearDisplay = true;
    action = "add";
}

void Qalculator::subButton()
{
    temp1 = ui->display->text().toDouble();
    clearDisplay = true;
    action = "sub";
}

void Qalculator::multButton()
{
    temp1 = ui->display->text().toDouble();
    clearDisplay = true;
    action = "mult";
}

void Qalculator::divButton()
{
    temp1 = ui->display->text().toDouble();
    clearDisplay = true;
    action = "div";
}

void Qalculator::isButton()
{
    temp2 = ui->display->text().toDouble();
    if (action == "add")
        erg = temp1 + temp2;
    else if (action == "sub")
        erg = temp1 - temp2;
    else if (action == "mult")
        erg = temp1 * temp2;
    else if (action == "div")
        erg = temp1 / temp2;

    ui->display->setText(QString::number(erg));
}

void  Qalculator::changeSign()
{
    double displayContent = ui->display->text().toDouble();
    if (displayContent > 0)
    {
        QString displayContent = ui->display->text();
        displayContent = "-" + displayContent;
        ui->display->setText(displayContent);
    }
    else if (displayContent < 0)
    {
        QString displayContent = ui->display->text();
        displayContent.remove(0,1);
        ui->display->setText(displayContent);
    }
}

void Qalculator::store()
{
    tempStore = ui->display->text().toDouble();
    storeIt = true;
}
void Qalculator::recall()
{
    recallIt = true;
}

void Qalculator::clearEntry()
{
    ui->display->clear();
    ui->display->setText("0");
    temp1 = 0;
    temp2 = 0;
    erg = 0;
    dotExists = false;
    clearDisplay = false;
    storeIt = false;
    recallIt = false;
    action = "";
}

void Qalculator::showPI()
{
    ui->display->setText(QString::number(PI));
    clearDisplay = true;
}

void Qalculator::back()
{
    QString displayContent = ui->display->text();
    displayContent.chop(1);
    if (displayContent == "")
    {
        ui->display->setText("0");
        return;
    }
    ui->display->setText(displayContent);
}

void Qalculator::calcSIN()
{
    double displayContent = ui->display->text().toDouble();
    double DegSIN = sin((displayContent*PI)/180);
    ui->display->setText(QString::number(DegSIN));

    clearDisplay = true;
}
void Qalculator::calcCOS()
{
    double displayContent = ui->display->text().toDouble();
    double DegCOS = cos((displayContent*PI)/180);
    ui->display->setText(QString::number(DegCOS));

    clearDisplay = true;
}
void Qalculator::calcTAN()
{
    double displayContent = ui->display->text().toDouble();
    double DegTAN = tan((displayContent*PI)/180);
    ui->display->setText(QString::number(DegTAN));

    clearDisplay = true;
}

void Qalculator::calcSQRT()
{
    double displayContent = ui->display->text().toDouble();
    ui->display->setText(QString::number(sqrt(displayContent)));

    clearDisplay = true;
}

void Qalculator::calcSquare()
{
    double displayContent = ui->display->text().toDouble();
    ui->display->setText(QString::number(displayContent*displayContent));

    clearDisplay = true;
}

void Qalculator::percent()
{
    double displayContent = ui->display->text().toDouble();
    tempPercent = displayContent / 100;
    ui->display->setText(QString::number(tempPercent));
    calcPercent = true;
    action = "percent";
}
