#ifndef QALCULATOR_H
#define QALCULATOR_H

#include <QtWidgets/QToolButton>
#include <cmath>

namespace Ui
{
    class QalculatorClass;
}

class Qalculator : public QWidget
{
    Q_OBJECT

public:
    Qalculator(QWidget *parent = 0);
    ~Qalculator();

private:
    Ui::QalculatorClass *ui;

private slots:
    void num0();
    void num1();
    void num2();
    void num3();
    void num4();
    void num5();
    void num6();
    void num7();
    void num8();
    void num9();
    void dotButton();
    void isButton();
    void clearButton();
    void addButton();
    void subButton();
    void multButton();
    void divButton();
    void changeSign();
    void store();
    void recall();
    void clearEntry();
    void showPI();
    void back();
    void calcSIN();
    void calcCOS();
    void calcTAN();
    void calcSQRT();
    void calcSquare();
    void percent();
};

#endif // QALCULATOR_H
